Option Strict Off
Option Explicit On
Module basMain
	'****************************************************************************
	'*
	'*      EmuTool
	'*
	'* @Author: TheyKilledKenny
	'* @Date:   05 Oct 2019
	'*
	'*  Funzioni implementate:
	'*  Copia della partizione nascosta della emuMMC Atmosphere su file
	'*      - il file emummc.ini deve puntare alla partizione interessata
	'*          (cio dal menu Kosmos deve essere selezionata la emunand che si vuole copiare)
	'*      - i file sono utilizzabili come emuMMC su file
	'*          - Struttura cartelle compatibile per drag&drop sulla root della sd
	'*          - crea emummc.ini compatibile Atmosphere/Kosmos
	'*          - crea file file_based compatibile con Kosmos
	'*      - Indica qual' la cartella "Nintendo" collegata alla partizione i copia
	'*
	'*  Copia della partizione nascosta della Emunand SXOS su file
	'*      - Il file  utilizzabile come emunand su file
	'*          - Struttura cartelle compatibile per drag&drop sulla root della sd
	'*      - E' necessario copiare manualmente la cartella Emutendo per mantenere i software installati
	'*
	'*  - SX Check stato attuale Emunand. Se abilitata la emu su hidden, la emu su file non funzona
	'*  - SX Inserito switch per cambiare tipo di emunand
	'*
	'*  - Ripristino partizione nascosta Atmosphere
	'*    necessario indicare il settore di ripristino
	'*      - Creazione emummc.ini adeguato alla partizione
	'*
	'*  - Ripristino partizione nascosta SxOs
	'*
	'*  Bachi noti:
	'*  - necessario allineare i trunk per Atmosphere su File a 4MB, potrebbe essere sufficiente usare la corretta dimensione file
	'*    al posto di usare quella di SX
	'*
	'*  Da implementare:
	'*
	'*  - possibilit di individuare le partizioni, il ciclo esiste gi ed  il medesimo usato per individuare il nome lettera drive
	'*
	'*****************************************************************************************
	
	
	
	
	'Simulate a static class in a more object oriented language
	'This module is used as the main Drive list class
    Public g_cDrives As Collection

    Public mainForm As frmMain
	
	'Public Const EMU_SX_1024_SECTOR As Currency = 0
	'Public Const EMU_SX_1024_LENGHT As Long = 2
	
	Public Const EMU_SX_ENABLE_SECTOR As Decimal = 0.0001@
	
	Public Const EMU_SX_BOOT0_SECTOR As Decimal = 0.0002@
	Public Const EMU_BOOT0_LENGHT As Integer = 8192
	
	'Public Const EMU_SX_BOOT1_SECTOR As Currency = 0.8194@
	Public Const EMU_BOOT1_LENGHT As Integer = 8192
	
	'Public Const EMU_SX_NAND_SECTOR As Currency = 1.6386@
	Public Const EMU_NAND_LENGHT As Integer = 61071360
	
	Public Const EMU_SX_NAND_TRUNK_SIZE As Integer = 8388352 'Last trunk should be 2352896
	Public Const EMU_SX_NAND_LAST_TRUNK_SIZE As Integer = 2352896 'Last trunk should be 2352896
	
	Public Const EMU_AMS_NAND_TRUNK_SIZE As Integer = 8323072
	Public Const EMU_AMS_NAND_LAST_TRUNK_SIZE As Integer = 2809856
	
	Public Const EMU_BLOCK_SIZE As Decimal = 512
	
	Public Const EMU_SX_BOOT0_PATH As String = "\sxos\Emunand\boot0.bin"
	Public Const EMU_SX_BOOT1_PATH As String = "\sxos\Emunand\boot1.bin"
	Public Const EMU_SX_RAWNA_PATH As String = "\sxos\Emunand\full.0#.bin"
	
	Public Const EMU_ATM_BOOT0_PATH As String = "\eMMC\BOOT0"
	Public Const EMU_ATM_BOOT1_PATH As String = "\eMMC\BOOT1"
	Public Const EMU_ATM_RAWNA_PATH As String = "\eMMC\0#"
	
	Public Enum enEmuType
		enNone = 0
		enAtmHidden = 1
		enAtmFile = 2
		enSxHidden = 3
		enSxFile = 4
		enHekBack = 5
	End Enum
	
	Public g_bFindAllDrives As Boolean
	Public g_bStopOperations As Boolean
    Public lblStatus As System.Windows.Forms.Label


	'Fill Drives collection with system retrieved informations
	'TODO: Error checking
	Public Sub FindDrives()
		
		On Error GoTo ERR_SUB
		
		Dim oDrive As clsDrive
		Dim List As Object
		'UPGRADE_NOTE: Object  stato aggiornato a Object_Renamed. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Object_Renamed As Object
		
		'Initialize the Drives collections
		g_cDrives = New Collection
		
		'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto GetObject().InstancesOf. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
		List = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_DiskDrive")
		
		For	Each Object_Renamed In List
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.MediaType. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
            If (Trim(LCase(Object_Renamed.MediaType.ToString())) <> "fixed hard disk media" And Trim(LCase(Object_Renamed.MediaType.ToString())) <> "fixed	hard disk media") Or g_bFindAllDrives Then
                oDrive = New clsDrive
                oDrive.init(Object_Renamed)
                g_cDrives.Add(oDrive, oDrive.drvDeviceID.ToString)

            End If
			
		Next Object_Renamed

EXIT_SUB: 
		
		Exit Sub
		
ERR_SUB: 
		
		Resume EXIT_SUB
		
	End Sub
	
	'Ready for a multilanguage version
	'All text should be passed by this function.
	Public Function LangLabel(ByRef sKey As String, ByRef sDefault As String) As String
		LangLabel = sDefault
	End Function
End Module