Option Strict Off
Option Explicit On
Friend Class clsDrive
	'*****************************************************
	'*
	'* Class Created by TheyKilledKenny on 28 Sept 2019
	'*
	'* heavily modified to correct the 64bit sector number for big SD
	'* Drive information and Read/write procedures
	'*
	'*****************************************************
	
	'* Derived from the original work of:
	'
	'*****************************************************************
	' Module for performing Direct Read/Write access to disk sectors
	'
	' Written by Arkadiy Olovyannikov (ark@fesma.ru)
	'*****************************************************************
	
	
	'Self explaing Variable names
	'Capabilities={3,4,7}
	'CapabilityDescriptions={"Random Access","Supports Writing","Supports Removable Media"}
	Public drvBytesPerSector As Short '= 512
	Public drvDescription As String '=Disk drive
	Public drvDeviceID As String '=\\.\PHYSICALDRIVE1
	Public drvIndex As Short 'indice nelle liste
	Public drvMediaType As String '=Removable Media
	Public drvModel As String '=SDXC Card
	Public drvName As String '=\\.\PHYSICALDRIVE1
	Public drvPartitions As Short '= 2
	Public drvSize As Single '196863851520#
	Public drvStatus As String '= OK
	Public drvTotalSectors As Integer '= 384499710
	Public drvStartSector As Decimal
	Public drvNinFolder As String
	Public drvEmuFolder As String
	
	Public Partitions As Collection 'of Partition type
	
	Private abResult() As Byte
	Private m_aSxEmuDataDisable(511) As Byte
	Private m_aSxEmuDataEnable(511) As Byte
	Private m_bSxEmuEnabled As Boolean
	Private iDrvIndex As Short
	
	Const FILE_BEGIN As Short = 0
	
	'UPGRADE_ISSUE: La dichiarazione di un parametro 'As Any' non  supportata. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
	'UPGRADE_ISSUE: La dichiarazione di un parametro 'As Any' non  supportata. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
    'Private Declare Sub memcpy Lib "kernel32"  Alias "RtlMoveMemory"(ByRef Destination As Any, ByRef Source As Any, ByVal Length As Integer)
	
	
	
	''''Private Function MAKEWORD(ByVal bLo As Byte, ByVal bHi As Byte) As Integer
	''''
	''''    If bHi And &H80 Then
	''''        MAKEWORD = (((bHi And &H7F) * 256) + bLo) Or &H8000
	''''    Else
	''''        MAKEWORD = (bHi * 256) + bLo
	''''    End If
	''''
	''''End Function
	
	
	'UPGRADE_NOTE: Class_Initialize  stato aggiornato a Class_Initialize_Renamed. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
	Private Sub Class_Initialize_Renamed()
		
		Dim idx As Short
		
		'Defaults
		drvBytesPerSector = 0
		drvDescription = ""
		drvDeviceID = ""
		drvIndex = -1
		drvMediaType = "NA"
		drvModel = "NA"
		drvName = "NA"
		drvPartitions = 0
		drvSize = 0
		drvStatus = "NA"
		drvTotalSectors = 0
		BytesPerSector = 512@
		iDrvIndex = 0
		
		'Initialize Array for Sx Emunand partition enabled/disabled
		For idx = 0 To 511
			m_aSxEmuDataDisable(idx) = 0
			m_aSxEmuDataEnable(idx) = 0
		Next 
		
		'Set relevant bytes for Sx Partition Emu enabler
		m_aSxEmuDataEnable(0) = &H54
		m_aSxEmuDataEnable(1) = &H58
		m_aSxEmuDataEnable(2) = &H4E
		m_aSxEmuDataEnable(3) = &H41
		m_aSxEmuDataEnable(4) = &H4E
		m_aSxEmuDataEnable(5) = &H44
		'm_aSxEmuDataEnable(6,7,8,9,10, 11, 12, 13, 14, 15)=&H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0,
		m_aSxEmuDataEnable(16) = &H54
		m_aSxEmuDataEnable(17) = &H65
		m_aSxEmuDataEnable(18) = &H61
		m_aSxEmuDataEnable(19) = &H6D
		m_aSxEmuDataEnable(20) = &H20
		m_aSxEmuDataEnable(21) = &H58
		m_aSxEmuDataEnable(22) = &H65
		m_aSxEmuDataEnable(23) = &H63
		m_aSxEmuDataEnable(24) = &H75
		m_aSxEmuDataEnable(25) = &H74
		m_aSxEmuDataEnable(26) = &H65
		m_aSxEmuDataEnable(27) = &H72
		m_aSxEmuDataEnable(28) = &H20
		m_aSxEmuDataEnable(29) = &H96
		m_aSxEmuDataEnable(30) = &H20
		m_aSxEmuDataEnable(31) = &H52
		m_aSxEmuDataEnable(32) = &H6F
		m_aSxEmuDataEnable(33) = &H63
		m_aSxEmuDataEnable(34) = &H6B
		m_aSxEmuDataEnable(35) = &H69
		m_aSxEmuDataEnable(36) = &H6E
		m_aSxEmuDataEnable(37) = &H67
		m_aSxEmuDataEnable(38) = &H20
		m_aSxEmuDataEnable(39) = &H74
		m_aSxEmuDataEnable(40) = &H68
		m_aSxEmuDataEnable(41) = &H65
		m_aSxEmuDataEnable(42) = &H20
		m_aSxEmuDataEnable(43) = &H53
		m_aSxEmuDataEnable(44) = &H77
		m_aSxEmuDataEnable(45) = &H69
		m_aSxEmuDataEnable(46) = &H74
		m_aSxEmuDataEnable(47) = &H63
		m_aSxEmuDataEnable(48) = &H68
		m_aSxEmuDataEnable(49) = &H20
		m_aSxEmuDataEnable(50) = &H66
		m_aSxEmuDataEnable(51) = &H6F
		m_aSxEmuDataEnable(52) = &H72
		m_aSxEmuDataEnable(53) = &H65
		m_aSxEmuDataEnable(54) = &H76
		m_aSxEmuDataEnable(55) = &H65
		m_aSxEmuDataEnable(56) = &H72
		m_aSxEmuDataEnable(57) = &H20
		m_aSxEmuDataEnable(58) = &H61
		m_aSxEmuDataEnable(59) = &H6E
		m_aSxEmuDataEnable(60) = &H64
		m_aSxEmuDataEnable(61) = &H20
		m_aSxEmuDataEnable(62) = &H62
		m_aSxEmuDataEnable(63) = &H65
		m_aSxEmuDataEnable(64) = &H79
		m_aSxEmuDataEnable(65) = &H6F
		m_aSxEmuDataEnable(66) = &H6E
		m_aSxEmuDataEnable(67) = &H64
		'm_aSxEmuDataEnable(68)=&H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0
		m_aSxEmuDataEnable(81) = &H20
		m_aSxEmuDataEnable(82) = &HA4
		m_aSxEmuDataEnable(83) = &H3
		m_aSxEmuDataEnable(84) = &H2
		'm_aSxEmuDataEnable(85)=&H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0, &H0
		
	End Sub
	Public Sub New()
		MyBase.New()
		Class_Initialize_Renamed()
	End Sub
	
	
	'Write the all 0 or the TX bytes to disable/enable the sxos emunand
	Public Property sxPartitionEnabled() As Boolean
		Get
			sxPartitionEnabled = m_bSxEmuEnabled
		End Get
		Set(ByVal Value As Boolean)
			
			Dim cbytes As Integer
			Dim res As Integer
			Dim aSdBuf() As Byte
			Dim idx As Short
			
			cbytes = 512
			If Value Then
				res = DirectWriteDriveNT(drvDeviceID, EMU_SX_ENABLE_SECTOR, m_aSxEmuDataEnable, cbytes)
				m_bSxEmuEnabled = True
				
			Else
				res = DirectWriteDriveNT(drvDeviceID, EMU_SX_ENABLE_SECTOR, m_aSxEmuDataDisable, cbytes)
				m_bSxEmuEnabled = False
				
			End If
			
			MsgBox(LangLabel("IDidIt", "I did it!"), MsgBoxStyle.OKOnly, LangLabel("Done", "Done !"))
			
			
			
		End Set
	End Property
	
	'Set all properties based on the Disk object passed as arguments
	Public Sub init(ByRef oInit As Object)
		
		Dim col As New Collection
		'UPGRADE_NOTE: Object  stato aggiornato a Object_Renamed. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Object_Renamed As Object
		Dim List As Object
		Dim v As Object
		
		Dim aSdBuf() As Byte
		Dim res As Integer
		Dim idx As Short
		Dim cini As cInifile
		
		Dim prt As clsPartition
		If Not oInit Is Nothing Then
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.BytesPerSector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvBytesPerSector = oInit.BytesPerSector
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Description. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvDescription = oInit.Description
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.DeviceID. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvDeviceID = oInit.DeviceID
			drvIndex = -1
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Index. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			iDrvIndex = oInit.Index
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.MediaType. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvMediaType = oInit.MediaType
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Model. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvModel = oInit.Model
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Name. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvName = oInit.Name
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Partitions. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvPartitions = oInit.Partitions
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Size. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvSize = oInit.Size
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.Status. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvStatus = oInit.Status
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto oInit.TotalSectors. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			drvTotalSectors = oInit.TotalSectors
			
			'        : Name : "SectorsPerTrack" : String : clsDrive.init -----         : Name : "SectorsPerTrack" : String : clsDrive.init
			'        : Name : "TracksPerCylinder" : String : clsDrive.init  --- Name : "TotalCylinders" : String : clsDrive.init    ---
			'        : Name : "TotalTracks" : String : clsDrive.init -----         : Name : "TotalSectors" : String : clsDrive.init   -----         : Name : "TotalHeads" : String : clsDrive.init  ------
			
			
			
			'Find the drive letter
			'This piece of code is useful also for retrive partititon information about SD card
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto GetObject().InstancesOf. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			List = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_DiskDriveToDiskPartition")
			
			For	Each Object_Renamed In List
				
				'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.Antecedent. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If Replace(Replace(Split(Object_Renamed.Antecedent, "=")(1), "\\", "\"), """", "") = drvDeviceID Then
					'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.Dependent. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					col.Add(Replace(Split(Object_Renamed.Dependent, "=")(1), """", ""), Replace(Split(Object_Renamed.Dependent, "=")(1), """", "")) '
				End If
			Next Object_Renamed
			
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto GetObject().InstancesOf. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			List = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_LogicalDiskToPartition")
			For	Each v In col
				For	Each Object_Renamed In List
					'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto v. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.Antecedent. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.Dependent. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
					If Replace(Split(Object_Renamed.Antecedent, "=")(1), """", "") = v Then drvName = Replace(Split(Object_Renamed.Dependent, "=")(1), """", "")
				Next Object_Renamed
			Next v
			
			
			Partitions = New Collection
			
			
			'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto GetObject().InstancesOf. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
			List = GetObject("winmgmts:{impersonationLevel=impersonate}").InstancesOf("Win32_DiskPartition")
			For	Each Object_Renamed In List
				'UPGRADE_WARNING: Impossibile risolvere la propriet predefinita dell'oggetto Object_Renamed.DiskIndex. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6A50421D-15FE-4896-8A1B-2EC21E9037B2"'
				If iDrvIndex = Object_Renamed.DiskIndex Then
					Debug.Print("Object.Caption=" & Object_Renamed.Caption)
					Debug.Print("Object.Description=" & Object_Renamed.Description)
					Debug.Print("Object.DeviceID=" & Object_Renamed.DeviceID)
					Debug.Print("Object.DiskIndex=" & Object_Renamed.DiskIndex)
					Debug.Print("Object.Index=" & Object_Renamed.Index)
					Debug.Print("Object.Name=" & Object_Renamed.Name)
					Debug.Print("Object.NumberOfBlocks=" & Object_Renamed.NumberOfBlocks)
					Debug.Print("Object.Size=" & Object_Renamed.Size)
					Debug.Print("Object.StartingOffset=" & Object_Renamed.StartingOffset)
					Debug.Print("Object.Type=" & Object_Renamed.Type)
					
					Debug.Print(" ")
					
					prt = New clsPartition
					
                    prt.DiskIndex = Object_Renamed.DiskIndex
					prt.NumberOfBlocks = Object_Renamed.NumberOfBlocks
					prt.PartitionIndex = Object_Renamed.Index
					prt.StartingAddress = Object_Renamed.StartingOffset
					prt.Size = Object_Renamed.Size / 10000@
					prt.Name = Object_Renamed.Name
					
					Partitions.Add(prt, "P" & CStr(prt.PartitionIndex))
					
					'If Object.DeviceID = v Then drvName = Replace(Split(Object.Dependent, "=")(1), """", "")
					
				End If
				
			Next Object_Renamed
			
			
			
			
			
			
			
			
		Else
			drvBytesPerSector = 0
			drvDescription = ""
			drvDeviceID = ""
			drvIndex = -1
			drvMediaType = "NA"
			drvModel = "NA"
			drvName = "NA"
			drvPartitions = 0
			drvSize = 0
			drvStatus = "NA"
			drvTotalSectors = 0
			
		End If
		
		'Check if SD is TX Emunand enabled
        res = DirectReadDriveNT(drvDeviceID, 1, aSdBuf, 512)
		
		If res > 0 Then
			'sufficienti i primi 85bytes
			For idx = 0 To 85
				If aSdBuf(idx) = m_aSxEmuDataEnable(idx) Then
					m_bSxEmuEnabled = True
				Else
					m_bSxEmuEnabled = False
					Exit For
				End If
			Next 
		Else
			MsgBox("Unable to read from SD card, maybe I need Administrative rights to access your reader" & vbCrLf & "Please restart the software using right click and Start as Administrator", MsgBoxStyle.OKOnly, "Error!")
		End If
		
		'If not an SXOS partition Emu check if there is an Atmo Emu by reading emummc.ini on SD
		If Not m_bSxEmuEnabled Then
			
			cini = New cInifile
			With cini
				.Path = drvName & "\emummc\emummc.ini"
				.Section = "emummc"
				
				.Key = "sector"
				.Default_Renamed = CStr(-1)
				
				'Questo "appoggia" il valore a destra, perch la virgola  fittizia nei currency
				drvStartSector = CDec(Replace(.Value, "0x", "&h")) / 10000@
				
				
				.Key = "path"
				.Default_Renamed = "\emummc"
				drvEmuFolder = Replace(.Value, "/", "\")
				
				.Key = "nintendo_path"
                .Default_Renamed = "emuMMC/RAW9/Nintendo"
				drvNinFolder = Replace(.Value, "/", "\")
				
			End With
			'UPGRADE_NOTE:  possibile che l'oggetto cini non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
			cini = Nothing
			
		Else 'Se  una Emu sxos imposta i valori predefiniti.
			
			'imposto il settore a 2
			drvStartSector = 0.0002@
			drvEmuFolder = "sxos/Emunand"
			drvNinFolder = "Emutendo"
			
		End If
		
		
	End Sub
	
	'Read data from starting sector and write it to the file referred as lFileID (open) or HF (HugeBinaryFile)
	Public Function readDataToFileId(ByRef lStartSect As Decimal, ByVal lNumOfSect As Integer, ByVal lFileID As Integer, Optional ByRef HF As HugeBinaryFile = Nothing) As Integer
		
		Dim iSecNum As Short
		Dim Buffer() As Byte
		Dim res As Integer
		
		Dim SecToWrite As Decimal
		Dim RemainingSect As Decimal
		Dim WrittenSectors As Decimal
		Dim idx As Integer
		
		Dim MaxSector As Decimal
		MaxSector = 6.5535@ ' / 10000@
		
		
		On Error GoTo ERR_FUNCT
		
		RemainingSect = CDec(lNumOfSect) / 10000@
		WrittenSectors = 0
		
		
		Do 
			If (RemainingSect > MaxSector) Then
				SecToWrite = MaxSector
				RemainingSect = RemainingSect - MaxSector
			Else
				SecToWrite = RemainingSect
				RemainingSect = 0
			End If
			
			res = DirectReadDriveNT(drvDeviceID, lStartSect + WrittenSectors, Buffer, EMU_BLOCK_SIZE * (SecToWrite * 10000@))
			
			If res > 0 Then
				
				If HF Is Nothing Then
					'UPGRADE_WARNING: Put  stato aggiornato a FilePut e ha un nuovo comportamento. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="9B7D5ADD-D8FE-4819-A36C-6DEDAF088CC7"'
					FilePut(lFileID, Buffer, CInt(1 + (WrittenSectors * EMU_BLOCK_SIZE * 10000)))
				Else
					HF.SeekAbsolute((WrittenSectors * EMU_BLOCK_SIZE * 10000))
					HF.WriteBytes(Buffer)
				End If
				
				WrittenSectors = WrittenSectors + SecToWrite
				
				lblStatus.Text = "Written Blocks: " & VB6.Format(CStr(WrittenSectors * 10000@), "#,###")
				System.Windows.Forms.Application.DoEvents()
				
				If g_bStopOperations Then Exit Function
				
			Else
				MsgBox(LangLabel("ErroreLettura", "Error reading disk, start EmuTool in Administrative mode"))
				Exit Do
			End If
			
		Loop While RemainingSect > 0
		
		
		
EXIT_FUNCT: 
		Exit Function
		
ERR_FUNCT: 
		
		If Err.Number = 1 Then
			Resume 
		Else
			MsgBox(LangLabel("Errore", "Errore") & ": " & Err.Number & " - " & Err.Description)
			Resume EXIT_FUNCT
		End If
		
	End Function
	
	'Procedure to read data from a HF file and copy to the drive startinf from the specified sector
	Public Function readDataFromFileId(ByRef lStartSect As Decimal, ByRef HF As HugeBinaryFile) As Integer
		
		
		Dim iSecNum As Short
		Dim Buffer() As Byte
		Dim res As Integer
		
		Dim SecToWrite As Decimal
		Dim RemainingSect As Decimal
		Dim WrittenSectors As Decimal
		Dim idx As Integer
		
		Dim MaxSector As Decimal
		MaxSector = 6.5535@ ' / 10000@
		
		
		On Error GoTo ERR_FUNCT
		
		RemainingSect = (HF.FileLen_Renamed / EMU_BLOCK_SIZE) / 10000@
		WrittenSectors = 0
		
		
		Do 
			If (RemainingSect > MaxSector) Then
				SecToWrite = MaxSector
				RemainingSect = RemainingSect - MaxSector
			Else
				SecToWrite = RemainingSect
				RemainingSect = 0
			End If
			
			'res = DirectReadDriveNT(drvDeviceID, lStartSect + WrittenSectors, Buffer(), EMU_BLOCK_SIZE * (SecToWrite * 10000@))
			'
			ReDim Buffer(EMU_BLOCK_SIZE * (SecToWrite * 10000@) - 1)
			HF.SeekAbsolute((WrittenSectors * EMU_BLOCK_SIZE * 10000@))
			res = HF.ReadBytes(Buffer)
			
			If res > 0 Then
				
				res = DirectWriteDriveNT(drvDeviceID, lStartSect + WrittenSectors, Buffer, SecToWrite * EMU_BLOCK_SIZE * 10000@)
				
				WrittenSectors = WrittenSectors + SecToWrite
				
				lblStatus.Text = "Written Blocks: " & VB6.Format(CStr(WrittenSectors * 10000@), "#,###")
				System.Windows.Forms.Application.DoEvents()
				
				If g_bStopOperations Then Exit Function
				
			Else
				MsgBox(LangLabel("ErroreLettura", "Error reading disk, start EmuTool in Administrative mode"))
				Exit Do
			End If
			
		Loop While RemainingSect > 0
		
		
		
EXIT_FUNCT: 
		Exit Function
		
ERR_FUNCT: 
		
		If Err.Number = 1 Then
			Resume 
		Else
			MsgBox(LangLabel("Errore", "Errore") & ": " & Err.Number & " - " & Err.Description)
			Resume EXIT_FUNCT
		End If
		
	End Function


    Shadows ReadOnly Property toString() As String
        Get
            toString = drvName & "   " & drvModel & " " & VB6.Format(CStr(drvSize / (CInt(1024) * CInt(1024))), "#,### MByte ")
        End Get
    End Property


End Class