Option Strict Off
Option Explicit On
Module diskio
	'*****************************************************
	'*
	'* modified by TheyKilledKenny on 28 Sept 2019
	'*
	'* rewritten the main functions DirectReadDriveNT and DirectWriteDriveNT
	'* because Long datatype is limited. Converted to Currency as it is a plain 64bit with virtual fixed comma
	'*
	'* Drive information and Read/write procedures
	'*
	'*****************************************************
	
	'Rem 8-11-2008 'ByRef lpBuffer' and 'cBytes' long return modification
	'Rem by Erdogan Tan
	'Rem ***
	'Rem "DirectReadDriveNT" function was originally written
	'Rem by Arkadiy Olovyannikov
	'Rem with a variant return
	'Rem ... for reading logical (dos/windows) drive/disk sectors...
	'Rem ***
	'Rem Physical disk read/write features/procedures is written by Erdogan Tan
	'Rem by using information on Microsoft Developers Network (MSDN) web site
	'Rem http://msdn.microsoft.com/tr-tr/library/aa363858(en-us,VS.85).aspx
	'Rem Adapted to Visual Basic (5.0) code by Erdogan Tan on 27-10-2008
	'Rem ... and successfully realized on Windows XP SP3 (8-11-2008)
	'Rem This code is successfully running on Windows XP Home & Professional.
	
	'**********************************************************
	'VB Project FILE: diskio.bas  (diskio module)
	'************ VB 5.0/6.0 Source Code **********************
	
	'*****************************************************************
	' Module for performing Direct Read/Write access to disk sectors
	'
	' Written by Arkadiy Olovyannikov (ark@fesma.ru)
	'*****************************************************************
	
	'*************Win9x direct Read/Write Staff**********
	
	Public Enum FAT_WRITE_AREA_CODE
		FAT_AREA = &H2001
		ROOT_DIR_AREA = &H4001
		DATA_AREA = &H6001
	End Enum
	
	Public Structure DISK_IO
		Dim dwStartSector As Integer
		Dim wSectors As Short
		Dim dwBuffer As Integer
	End Structure
	
	
	Public Const GENERIC_READ As Integer = &H80000000
	Public Const GENERIC_WRITE As Integer = &H40000000
	Public Const FILE_SHARE_READ As Integer = &H1
	Public Const FILE_SHARE_WRITE As Integer = &H2
	Public Const OPEN_EXISTING As Short = 3
	Public Const INVALID_HANDLE_VALUE As Short = -1
	
	Public Const FILE_ATTRIBUTE_NORMAL As Integer = &H80
	Public Const CREATE_ALWAYS As Short = 2
	Public Const OPEN_ALWAYS As Short = 4
	Public Const INVALID_SET_FILE_POINTER As Short = -1
	Public Const INVALID_FILE_SIZE As Short = -1
	
	Public Const FILE_BEGIN As Short = 0
	Public Const FILE_CURRENT As Short = 1
	Public Const FILE_END As Short = 2
	
	
	'''''Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (LpVersionInformation As OSVERSIONINFO) As Long
	Public Declare Function CreateFile Lib "kernel32"  Alias "CreateFileA"(ByVal lpFileName As String, ByVal dwDesiredAccess As Integer, ByVal dwShareMode As Integer, ByVal lpSecurityAttributes As Integer, ByVal dwCreationDisposition As Integer, ByVal dwFlagsAndAttributes As Integer, ByVal hTemplateFile As Integer) As Integer
	Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Integer) As Integer

    'UPGRADE_ISSUE: La dichiarazione di un parametro 'As Any' non  supportata. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
    'UPGRADE_ISSUE: La dichiarazione di un parametro 'As Any' non  supportata. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="FAE78A8D-8978-4FD4-8208-5B7324A8F795"'
    'Public Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Integer, ByVal dwIoControlCode As Integer, ByRef lpInBuffer As Any, ByVal nInBufferSize As Integer, ByRef lpOutBuffer As Any, ByVal nOutBufferSize As Integer, ByRef lpBytesReturned As Integer, ByVal lpOverlapped As Integer) As Integer
	Public Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Integer, ByVal lDistanceToMove As Integer, ByRef lpDistanceToMoveHigh As Integer, ByVal dwMoveMethod As Integer) As Integer
	
    Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Integer, ByRef lpBuffer As Long, ByVal nNumberOfBytesToRead As Integer, ByRef lpNumberOfBytesRead As Integer, ByVal lpOverlapped As Integer) As Integer
    Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Integer, ByVal Buffer As Byte(), ByVal nNumberOfBytesToRead As Integer, ByRef lpNumberOfBytesRead As Integer, ByVal lpOverlapped As Integer) As Integer

    Public Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Integer, ByRef lpFileSizeHigh As Integer) As Integer
    Public Declare Function WriteFile Lib "kernel32" (ByVal hFile As Integer, ByRef lpBuffer As Long, ByVal nNumberOfBytesToWrite As Integer, ByRef lpNumberOfBytesWritten As Integer, ByVal lpOverlapped As Integer) As Integer
	
	Public Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Integer) As Integer
	Public Declare Function LockFile Lib "kernel32" (ByVal hFile As Integer, ByVal dwFileOffsetLow As Integer, ByVal dwFileOffsetHigh As Integer, ByVal nNumberOfBytesToLockLow As Integer, ByVal nNumberOfBytesToLockHigh As Integer) As Integer
	Public Declare Function UnlockFile Lib "kernel32" (ByVal hFile As Integer, ByVal dwFileOffsetLow As Integer, ByVal dwFileOffsetHigh As Integer, ByVal nNumberOfBytesToUnlockLow As Integer, ByVal nNumberOfBytesToUnlockHigh As Integer) As Integer
	
	
	Public Structure TKK_Cur
		Dim Value As Decimal
	End Structure
	
	Public Structure Cur2Long
        Dim LowVal As UInteger
        Dim HighVal As UInteger
	End Structure
	
    Private C As ULong  ' TKK_Cur
    Private L As Cur2Long

    'Public Declare Sub CopyMemory Lib "kernel32"  Alias "RtlMoveMemory"(ByRef Destination As Any, ByRef Source As Any, ByVal Length As Integer)

    'Additions by Erdogan Tan
	Public BytesPerSector As Decimal
	
    'Replaced By TheyKilledKenny, not needed LoWord and HiWord doesn't work with Currency or double number (Mod does not work)
	
	'''''''Private Function IsWindowsNT() As Boolean
	'''''''   Dim verinfo As OSVERSIONINFO
	'''''''   verinfo.dwOSVersionInfoSize = Len(verinfo)
	'''''''   If (GetVersionEx(verinfo)) = 0 Then Exit Function
	'''''''   If verinfo.dwPlatformId = 2 Then IsWindowsNT = True
	'''''''End Function
	
	''''''''Private Function LoWord(ByVal dNum As Double) As Long
	''''''''    LoWord = CLng(dNum Mod 65536)
	''''''''End Function
	
	''''''''Private Function HiWord(ByVal dNum As Double) As Long
	''''''''    HiWord = CLng(dNum - (dNum Mod 65536))
	''''''''End Function
	''''''''
    'Replaced by TheyKilledKeny with this new function to convert to and from uLong <-> Low and High byte
    Private Sub Long2Int(ByVal UnsignedLong As ULong, ByRef LongLow As UInteger, ByRef LongHigh As UInteger)
        '&HFFFFFFFF unsigned = 4294967295
        LongHigh = (UnsignedLong And &HFFFFFFFF00000000) / &H100000000
        LongLow = UnsignedLong And &HFFFFFFFF
    End Sub

    Private Sub Int2Long(ByVal LongLow As UInteger, ByVal LongHigh As UInteger, ByRef UnsignedLong As ULong)
        UnsignedLong = (LongHigh * &H100000000) Or LongLow
    End Sub



    ''=============NT staff=============
    ''Read/Write drive with any file system
    '
    'Rem 8-11-2008 'ByRef lpBuffer' and 'cBytes' long return modification
    'Rem by Erdogan Tan
    'Rem ***
    'Rem "DirectReadDriveNT" function was originally written
    'Rem by Arkadiy Olovyannikov
    'Rem with a variant return
    'Rem ... for reading logical (dos/windows) drive/disk sectors...
    'Rem ***
    'Rem Physical disk read/write features/procedures is written by Erdogan Tan
    'Rem by using information on Microsoft Developers Network (MSDN) web site
    'Rem http://msdn.microsoft.com/tr-tr/library/aa363858(en-us,VS.85).aspx
    'Rem Adapted to Visual Basic (5.0) code by Erdogan Tan on 27-10-2008
    'Rem ... and successfully realized on Windows XP SP3 (8-11-2008)
    'Rem This code is successfully running on Windows XP Home & Professional.
    '''''''
    ''''''''''''Public Function DirectReadDriveNT(ByVal sDrive As String, ByVal iStartSec As Long, ByVal iOffset As Long, ByRef lpBuffer() As Byte, ByVal cbytes As Long) As Long
    ''''''''''''
    ''''''''''''    Dim hDevice As Long
    ''''''''''''    Dim abBuff() As Byte
    ''''''''''''    Dim nSectors As Integer
    ''''''''''''
    ''''''''''''    nSectors = Int((iOffset + cbytes - 1) / BytesPerSector) + 1
    ''''''''''''
    ''''''''''''    Rem hDevice = CreateFile("\\.\" & UCase(Left(sDrive, 1)) & ":", GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
    ''''''''''''    Rem 4-11-2008 Physical disk read/write modification
    ''''''''''''
    ''''''''''''    hDevice = CreateFile(sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
    ''''''''''''    If hDevice = INVALID_HANDLE_VALUE Then Exit Function
    ''''''''''''    Call SetFilePointer(hDevice, iStartSec * BytesPerSector, 0, FILE_BEGIN)
    ''''''''''''    ReDim lpBuffer(cbytes - 1)
    ''''''''''''    ReDim abBuff(nSectors * BytesPerSector - 1)
    ''''''''''''    Call ReadFile(hDevice, abBuff(0), UBound(abBuff) + 1, cbytes, 0&)
    ''''''''''''    CloseHandle hDevice
    ''''''''''''    CopyMemory lpBuffer(0), abBuff(iOffset), cbytes
    ''''''''''''    DirectReadDriveNT = cbytes
    ''''''''''''
    ''''''''''''End Function

    'Rewritten by TheyKiledKenny, the original one doesn't work for overflow on high ector number
    Public Function DirectReadDriveNT(ByVal sDrive As String, ByVal iStartSec As UInteger, ByRef lpBuffer() As Byte, ByVal cbytes As Integer) As Integer

        Dim hDevice As Integer
        'Dim abBuff() As Byte
        'Dim nSectors As Short

        hDevice = CreateFile(sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)

        If hDevice = INVALID_HANDLE_VALUE Then Exit Function

        C = iStartSec * BytesPerSector
        Long2Int(C, L.LowVal, L.HighVal)

        Call SetFilePointer(hDevice, L.LowVal, L.HighVal, FILE_BEGIN)

        ReDim lpBuffer(cbytes - 1)
        On Error GoTo AAAAAA

        Call ReadFile(hDevice, lpBuffer, UBound(lpBuffer) + 1, cbytes, 0)

        CloseHandle(hDevice)

        DirectReadDriveNT = cbytes

        Exit Function


AAAAAA:
        MsgBox(Err.Number & " - " & Err.Description)
        Resume




    End Function

    Public Function DirectWriteDriveNT(ByVal sDrive As String, ByVal iStartSec As Decimal, ByRef lpBuffer() As Byte, ByVal cbytes As Integer) As Boolean

        Dim hDevice As Integer
        Dim abBuff() As Byte
        Dim ab() As Byte
        Dim nRead As Integer

        hDevice = CreateFile(sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0)

        If hDevice = INVALID_HANDLE_VALUE Then
            DirectWriteDriveNT = False
            Exit Function
        End If

        C = iStartSec * BytesPerSector
        'UPGRADE_ISSUE: Impossibile assegnare un tipo a un altro utilizzando LSet. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="899FA812-8F71-4014-BAEE-E5AF348BA5AA"'
        Long2Int(C, L.LowVal, L.HighVal)
        'L = LSet(C)

        Call SetFilePointer(hDevice, L.LowVal, L.HighVal, FILE_BEGIN)

        Call LockFile(hDevice, L.LowVal, L.HighVal, cbytes, 0)

        DirectWriteDriveNT = WriteFile(hDevice, lpBuffer(0), UBound(lpBuffer) + 1, nRead, 0)

        Call FlushFileBuffers(hDevice)
        Call UnlockFile(hDevice, L.LowVal, L.HighVal, cbytes, 0)

        CloseHandle(hDevice)

    End Function
	
	'Deleted and Rewritten by TheyKilledKenny
	'
	'''''''Public Function DirectWriteDriveNT(ByVal sDrive As String, ByVal iStartSec As Long, ByVal iOffset As Long, ByRef lpBuffer() As Byte, ByVal cBytes As Long) As Long
	'''''''
	'''''''    Rem Dim hDevice As Long
	'''''''    Dim nSectors As Long
	'''''''    Dim nRead As Long
	'''''''    Rem Dim abBuff() As Byte
	'''''''
	'''''''    nSectors = Int((iOffset + cBytes - 1) / BytesPerSector) + 1
	'''''''    Rem hDevice = CreateFile("\\.\" & UCase(Left(sDrive, 1)) & ":", GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
	'''''''    Rem 4-11-2008 Physical disk read/write modification
	'''''''    Rem hDevice = CreateFile("\\.\" & sDrive, GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, 0&, OPEN_EXISTING, 0&, 0&)
	'''''''    Rem If hDevice = INVALID_HANDLE_VALUE Then Exit Function
	'''''''    ReDim abBuff(nSectors * BytesPerSector - 1) As Byte
	'''''''    Call DirectReadDriveNT(sDrive, iStartSec, 0, abBuff(), nSectors * BytesPerSector)
	'''''''    CopyMemory abBuff(iOffset), lpBuffer(0), cBytes
	'''''''    Rem 11-11-2008 Fixing 2 GB (32 bit - 64 bit) problem (to pass beyond 2 GB)
	'''''''    Rem If Fix64BitNumber(iStartSec, CLng(BytesPerSector), lDistanceToMove, lpDistanceToMoveHigh) <> True Then Exit Function
	'''''''    Call Fix64BitNumber(iStartSec, BytesPerSector, lDistanceToMove, lpDistanceToMoveHigh)
	'''''''    If lDistanceToMove <= &H7FFFFFFF Then
	'''''''       Call SetFilePointer(hDevice, CLng(lDistanceToMove), CLng(lpDistanceToMoveHigh), FILE_BEGIN)
	'''''''    Else
	'''''''       Call SetFilePointer(hDevice, &H7FFFFFFF, CLng(lpDistanceToMoveHigh), FILE_BEGIN)
	'''''''       lDistanceToMove = lDistanceToMove - &H7FFFFFFF
	'''''''       Call SetFilePointer(hDevice, CLng(lDistanceToMove), 0, FILE_CURRENT)
	'''''''    End If
	'''''''    Call LockFile(hDevice, CLng(lDistanceToMove), CLng(lpDistanceToMoveHigh), LoWord(nSectors * BytesPerSector), HiWord(nSectors * BytesPerSector))
	'''''''    Call WriteFile(hDevice, abBuff(0), UBound(abBuff) + 1, nRead, 0&)
	'''''''    Call FlushFileBuffers(hDevice)
	'''''''    Call UnlockFile(hDevice, CLng(lDistanceToMove), CLng(lpDistanceToMoveHigh), LoWord(nSectors * BytesPerSector), HiWord(nSectors * BytesPerSector))
	'''''''    Rem CloseHandle hDevice
	'''''''    Rem 8-11-2008 Count of written bytes is equal to the required byte count?
	'''''''    If nRead = UBound(abBuff) + 1 Then
	'''''''       Rem All of the requested bytes are written...
	'''''''       DirectWriteDriveNT = cBytes
	'''''''    Rem Else
	'''''''       Rem DirectWriteDriveNT = 0
	'''''''    End If
	'''''''End Function
End Module