Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports Microsoft.VisualBasic.PowerPacks
Friend Class frmMain
	Inherits System.Windows.Forms.Form
	'******************************************************************************************************
	' Scritto da TheyKilledKenny il 25 Sept 2019
	'   Spostato procedure di DirectReadDriveNT e DirectWriteDriveNT nel modulo diskio e rese pubbliche
	'   Completamente rivista la procedura di lettura dei dati
	'
	'*****************************************************************************************************
	
	'Frame Index
	Private Const FRAME_SOURCE As Short = 0
	Private Const FRAME_DESTINATION As Short = 1
	Private Const FRAME_SD As Short = 2
	Private Const FRAME_FILE As Short = 3
	
	Private m_enSrcType As basMain.enEmuType 'Contiene la scelta della sorgente
	Private m_enDstType As basMain.enEmuType 'Contiene la scelta della destinazione
	Private m_oSourceSd As clsDrive 'Contiene il drive attualmente selezionato
	Private m_oTargetSd As clsDrive 'Contiene il drive attualmente selezionato
	
	Private m_sSourcePath As String 'Contiene il percorso di destinazione dei file
	Private m_sSourceNin As String 'Contiene il percorso di destinazione dei file
	Private m_sTargetNin As String 'Contiene il percorso di destinazione dei file
	
	Private m_sOutPath As String 'Contiene il percorso di dove dover copiare i file finali
	
	Private m_sBoot0Path As String 'contiene il nome e percorso di boot0
	Private m_sBoot1Path As String 'contiene il nome e percorso di boot1
	Private m_sRawNandPath As String 'contiene il nome e percorso dei pezzi di rawnand
	
	Private m_sSBoot0Path As String 'contiene il nome e percorso di boot0
	Private m_sSBoot1Path As String 'contiene il nome e percorso di boot1
	Private m_sSRawNandPath As String 'contiene il nome e percorso dei pezzi di rawnand
	
	
	Private m_oDrive As clsDrive
	Private m_bLoadingForm As Boolean 'Is the form still loading? (or no operation on the control's events)
	
	
	'Set the flag to stop the operation
	Private Sub cmdStop_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStop.Click
		
		If MsgBox(LangLabel("SureCancelOp", "Are you sure you want to stop the job?"), MsgBoxStyle.Question + MsgBoxStyle.YesNo, LangLabel("Sure", "Really sure?")) = MsgBoxResult.Yes Then
			g_bStopOperations = True
		Else
			g_bStopOperations = False
		End If
		
	End Sub
	
	'Catch the click on Target Type
	'UPGRADE_WARNING: L'evento optDest.CheckedChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub optDest_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optDest.CheckedChanged
		If eventSender.Checked Then
			Dim Index As Short = optDest.GetIndex(eventSender)
			
			'riaccendi le options
			'EnableOpt
			
			m_enDstType = Index
			
			'Ripristina il drive da utilizzare
			txtSrcSd(1).Text = "Click to select SD Card"
			txtSrcSd(1).Font = VB6.FontChangeBold(txtSrcSd(1).Font, True)
			txtSrcSd(1).TextAlign = System.Windows.Forms.HorizontalAlignment.Center 'vbAlignLeft
			
		End If
	End Sub
	
	'Cattura l'evento di click sui pulsanti abilita e disabilita per SXOS
	'UPGRADE_WARNING: L'evento optSetSx.CheckedChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub optSetSx_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optSetSx.CheckedChanged
		If eventSender.Checked Then
			Dim Index As Short = optSetSx.GetIndex(eventSender)
			
			On Error GoTo ERR_SUB
			
			If Not m_bLoadingForm Then
				
				If Index = 0 Then
					m_oSourceSd.sxPartitionEnabled = True
					
				Else
					m_oSourceSd.sxPartitionEnabled = False
				End If
				
			End If
			
EXIT_SUB: 
			Exit Sub
			
ERR_SUB: 
			MsgBox("optSetSX Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
			Resume EXIT_SUB
			
			
		End If
	End Sub
	
	'Intercetta il click sul tipo di Sorgente
	' Abilita e disabilita i controlli sulla form in base alla scelta
	'
	'UPGRADE_WARNING: L'evento optSrc.CheckedChanged pu essere generato quando il form  inizializzato. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub optSrc_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optSrc.CheckedChanged
		If eventSender.Checked Then
			Dim Index As Short = optSrc.GetIndex(eventSender)
			
			'riaccendi le options
			EnableOpt()
			
			'Ripristina il drive da utilizzare
			txtSrcSd(0).Text = "Click to select SD Card"
			txtSrcSd(0).Font = VB6.FontChangeBold(txtSrcSd(0).Font, True)
			txtSrcSd(0).TextAlign = System.Windows.Forms.HorizontalAlignment.Center 'vbAlignLeft
			
			'UPGRADE_NOTE:  possibile che l'oggetto m_oSourceSd non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
			m_oSourceSd = Nothing
			
			
			Select Case Index
				
				Case basMain.enEmuType.enAtmHidden
					'Spegni le destinazioni che non servono
					optDest(basMain.enEmuType.enAtmHidden).Checked = False
					optDest(basMain.enEmuType.enAtmHidden).Enabled = False
					optDest(basMain.enEmuType.enSxHidden).Checked = False
					optDest(basMain.enEmuType.enSxHidden).Enabled = False
					txtSrcSd(0).Text = "Click to select SD Card"
					m_enSrcType = basMain.enEmuType.enAtmHidden
					
				Case basMain.enEmuType.enAtmFile
					'Spegni le destinazioni che non servono
					optDest(basMain.enEmuType.enAtmFile).Checked = False
					optDest(basMain.enEmuType.enAtmFile).Enabled = False
					txtSrcSd(0).Text = "Click to select Folder"
					m_enSrcType = basMain.enEmuType.enAtmFile
					
					
				Case basMain.enEmuType.enSxHidden
					'Spegni le destinazioni che non servono
					optDest(basMain.enEmuType.enAtmHidden).Checked = False
					optDest(basMain.enEmuType.enAtmHidden).Enabled = False
					optDest(basMain.enEmuType.enSxHidden).Checked = False
					optDest(basMain.enEmuType.enSxHidden).Enabled = False
					txtSrcSd(0).Text = "Click to select SD Card"
					m_enSrcType = basMain.enEmuType.enSxHidden
					
					
				Case basMain.enEmuType.enSxFile
					'Spegni le destinazioni che non servono
					optDest(basMain.enEmuType.enSxFile).Checked = False
					optDest(basMain.enEmuType.enSxFile).Enabled = False
					txtSrcSd(0).Text = "Click to select Folder"
					m_enSrcType = basMain.enEmuType.enSxFile
					
					
				Case basMain.enEmuType.enHekBack
					
					m_enSrcType = basMain.enEmuType.enHekBack
					
					
			End Select
			
		End If
	End Sub
	
	
	Private Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		
		On Error GoTo ERR_SUB

        'Initial settings from old Sub main
        'Do Not find Hard Disk at the beginning
        'If true it display also hard disks wich is dangerous
        g_bFindAllDrives = False

        'Turno off stop flag
        g_bStopOperations = False

		'Set starting flag to avoid other controls events
		m_bLoadingForm = True
		
		m_enSrcType = basMain.enEmuType.enNone 'Reset selected src type
		m_enDstType = basMain.enEmuType.enNone 'Reset selected dst type
		
		'optSrc(enAtmHidden).Value = True
		EnableForm(True)
		
		Me.Text = My.Application.Info.ProductName & " v" & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Revision
		
		SetInitialStatusBar()
		
		m_bLoadingForm = False
		
		
EXIT_SUB: 
		
		Exit Sub
		
ERR_SUB: 
		
		MsgBox("FormLoad Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
	End Sub
	
	
	Private Sub cmdStart_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStart.Click
		
		On Error GoTo ERR_SUB
		
		EnableForm(False)
		g_bStopOperations = False
		
		
		If MsgBox("Please check data again!" & vbCrLf & "Are you sure you want to continue?", MsgBoxStyle.Question + MsgBoxStyle.YesNo, "Confirm") = MsgBoxResult.Yes Then
			
			If (m_enSrcType = basMain.enEmuType.enAtmHidden Or m_enSrcType = basMain.enEmuType.enSxHidden) And (m_enDstType = basMain.enEmuType.enAtmFile Or m_enDstType = basMain.enEmuType.enSxFile) Then
				PartitionToFile()
				
			ElseIf (m_enSrcType = basMain.enEmuType.enAtmFile Or m_enSrcType = basMain.enEmuType.enSxFile Or m_enSrcType = basMain.enEmuType.enHekBack) And (m_enDstType = basMain.enEmuType.enAtmHidden Or m_enDstType = basMain.enEmuType.enSxHidden) Then 
				
				FileToPartition()
				
			Else
				FileToFile()
				
			End If
		End If
		
		
		
		
		
		EnableForm(True)
		
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("cmdStartClick Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
		
		
	End Sub
	
	'Enable/disable opt controls
	Private Sub EnableOpt(Optional ByVal bEnable As Boolean = True, Optional ByRef iWich As Short = 3)
		
		If (iWich And 2) > 0 Then
			optDest(basMain.enEmuType.enAtmHidden).Enabled = bEnable
			optDest(basMain.enEmuType.enAtmFile).Enabled = bEnable
			optDest(basMain.enEmuType.enSxHidden).Enabled = bEnable
			optDest(basMain.enEmuType.enSxFile).Enabled = bEnable
		End If
		If (iWich And 1) > 0 Then
			optSrc(basMain.enEmuType.enAtmHidden).Enabled = bEnable
			optSrc(basMain.enEmuType.enAtmFile).Enabled = bEnable
			optSrc(basMain.enEmuType.enSxHidden).Enabled = bEnable
			optSrc(basMain.enEmuType.enSxFile).Enabled = bEnable
		End If
		
	End Sub
	
	Private Sub EnableForm(ByVal bEnable As Boolean)
		
		cmdStart.Enabled = bEnable
		cmdStop.Enabled = Not bEnable
		
		'lstDrives.Enabled = bEnable
		Frame1(0).Enabled = bEnable
		Frame1(1).Enabled = bEnable
		
	End Sub
	
	
	Public Sub SetInitialStatusBar()
		
		fraStaturBar.Top = VB6.TwipsToPixelsY(VB6.PixelsToTwipsY(Me.ClientRectangle.Height) - VB6.PixelsToTwipsY(fraStaturBar.Height))
		
		lblStatusBar(4).Visible = True
		lblStatusBar(4).Text = My.Application.Info.ProductName & " v" & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Revision
		lblStatusBar(4).Text = lblStatusBar(4).Text & " - " & LangLabel("StatusBarText", My.Application.Info.Title & " by " & My.Application.Info.CompanyName & " (..." & My.Application.Info.Description & ")")
		
	End Sub
	
	'Inizializza la status bar con il testo predefinito per il conteggio e ritorna il panel in cui scrivere il conto
	Public Function SetCounterStatusBar(ByVal TotalSectors As Decimal) As System.Windows.Forms.Label
		
		lblStatusBar(4).Visible = False
		lblStatusBar(0).Text = "Written blocks: 0"
		lblStatusBar(1).Text = "Total Block: " & CStr(TotalSectors)
		lblStatusBar(2).Text = ""
		lblStatusBar(3).Text = My.Application.Info.ProductName & " v" & My.Application.Info.Version.Major & "." & My.Application.Info.Version.Minor & "." & My.Application.Info.Version.Revision
		
		SetCounterStatusBar = lblStatusBar(0)
		
	End Function
	
	'Set path and filenames according to user choice
	Private Function SetProperPath() As Boolean
		
		
		On Error GoTo ERR_SUB
		
		Dim tmpFileNo As Integer
		
		If m_oSourceSd Is Nothing Then
			If Trim(m_sSourcePath) = "" Then
				MsgBox(LangLabel("MissingSource", "Please choose a Source"), MsgBoxStyle.OKOnly, LangLabel("Errore", "Error"))
				SetProperPath = False
				Exit Function
			End If
		End If
		
		
		'Set source path
		If Trim(m_sSourcePath) = "" Then
			m_sSourcePath = m_oSourceSd.drvName & "\" & m_oSourceSd.drvEmuFolder
		End If
		
		Select Case m_enSrcType
			
			Case basMain.enEmuType.enAtmFile
				m_sSBoot0Path = m_sSourcePath & "\BOOT0" 'EMU_ATM_BOOT0_PATH
				m_sSBoot1Path = m_sSourcePath & "\BOOT1" 'EMU_ATM_BOOT1_PATH
				m_sSRawNandPath = m_sSourcePath & "\#" 'EMU_ATM_RAWNA_PATH
				
			Case basMain.enEmuType.enSxFile
				m_sSBoot0Path = m_sSourcePath & "\boot0.bin" 'EMU_SX_BOOT0_PATH
				m_sSBoot1Path = m_sSourcePath & "\boot1.bin" 'EMU_SX_BOOT1_PATH
				'm_sSRawNandPath = m_sSourcePath & "\full.0#.bin"    'EMU_SX_RAWNA_PATH
				m_sSRawNandPath = m_sSourcePath & "\full.#.bin" 'EMU_SX_RAWNA_PATH
				
			Case basMain.enEmuType.enHekBack
				m_sSBoot0Path = m_sSourcePath & "\BOOT0"
				m_sSBoot1Path = m_sSourcePath & "\BOOT1"
				m_sSRawNandPath = m_sSourcePath & "\rawnand.bin#"
				
				
			Case basMain.enEmuType.enAtmHidden
				m_sSBoot0Path = ""
				m_sSBoot1Path = ""
				m_sSRawNandPath = ""
				
			Case basMain.enEmuType.enSxHidden
				m_sSBoot0Path = ""
				m_sSBoot1Path = ""
				m_sSRawNandPath = ""
				
		End Select
		
		
		
		'Set target path
		
		If m_oTargetSd Is Nothing Then
			If Trim(m_sOutPath) = "" Then
				MsgBox(LangLabel("MissingTarget", "Please choose Target"), MsgBoxStyle.OKOnly, LangLabel("Errore", "Error"))
				SetProperPath = False
				Exit Function
			End If
		End If
		
		If Trim(m_sOutPath) = "" Then
			m_sOutPath = m_oTargetSd.drvName & "\" & m_oTargetSd.drvEmuFolder
		End If
		
		Select Case m_enDstType
			
			Case basMain.enEmuType.enAtmFile
				m_sBoot0Path = m_sOutPath & "\emummc\HPE0" & EMU_ATM_BOOT0_PATH
				m_sBoot1Path = m_sOutPath & "\emummc\HPE0" & EMU_ATM_BOOT1_PATH
				m_sRawNandPath = m_sOutPath & "\emummc\HPE0" & EMU_ATM_RAWNA_PATH
				
				On Error Resume Next
				MkDir(m_sOutPath & "\emummc")
				
				'Creo il file emummc.ini
				tmpFileNo = FreeFile
				FileOpen(tmpFileNo, m_sOutPath & "\emuMMC\emummc.ini", OpenMode.Output)
				PrintLine(tmpFileNo, "[emummc]")
				PrintLine(tmpFileNo, "enabled=1")
				PrintLine(tmpFileNo, "sector=0x0")
				PrintLine(tmpFileNo, "path=emuMMC/HPE0")
				PrintLine(tmpFileNo, "id=0x0000")
				PrintLine(tmpFileNo, "nintendo_path=emuMMC/HPE0/Nintendo")
				PrintLine(tmpFileNo, "")
				FileClose(tmpFileNo)
				
				MkDir(m_sOutPath & "\emummc\HPE0")
				Kill(m_sOutPath & "\emummc\HPE0\*.*")
				
				tmpFileNo = FreeFile
				FileOpen(tmpFileNo, m_sOutPath & "\emuMMC\HPE0\file_based", OpenMode.Output)
				FileClose(tmpFileNo)
				
				MkDir(m_sOutPath & "\emummc\HPE0\eMMC")
				Kill(m_sOutPath & "\emummc\HPE0\eMMC\*.*")
				On Error GoTo 0
				
			Case basMain.enEmuType.enSxFile
				m_sBoot0Path = m_sOutPath & EMU_SX_BOOT0_PATH
				m_sBoot1Path = m_sOutPath & EMU_SX_BOOT1_PATH
				m_sRawNandPath = m_sOutPath & EMU_SX_RAWNA_PATH
				
				'Elimina eventuali precedenti file
				On Error Resume Next
				MkDir(m_sOutPath & "\sxos")
				Kill(m_sOutPath & "\sxos\*.*")
				MkDir(m_sOutPath & "\sxos\Emunand")
				Kill(m_sOutPath & "\sxos\Emunand\*.*")
				On Error GoTo 0
				
			Case basMain.enEmuType.enAtmHidden
				m_sBoot0Path = ""
				m_sBoot1Path = ""
				m_sRawNandPath = ""
				
			Case basMain.enEmuType.enSxHidden
				m_sBoot0Path = ""
				m_sBoot1Path = ""
				m_sRawNandPath = ""
				
		End Select
		
		
		'Remove double slash to avoid compatibility issues
		m_sBoot0Path = Replace(m_sBoot0Path, "\\", "\")
		m_sBoot1Path = Replace(m_sBoot1Path, "\\", "\")
		m_sRawNandPath = Replace(m_sRawNandPath, "\\", "\")
		
		m_sSBoot0Path = Replace(m_sSBoot0Path, "\\", "\")
		m_sSBoot1Path = Replace(m_sSBoot1Path, "\\", "\")
		m_sSRawNandPath = Replace(m_sSRawNandPath, "\\", "\")
		
		
		SetProperPath = True
		
EXIT_SUB: 
		Exit Function
		
ERR_SUB: 
		MsgBox("SetPropetPath Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
		
	End Function
	
	
	'Read data from a starting sector in the selected drive and write it in files
	Private Sub PartitionToFile()
		
		Dim cini As cInifile 'Classe di gestione dei file INI
		'Dim oDrv               As clsDrive
		
		Dim tmpFileNo As Integer
		Dim iTrunkNum As Short
		Dim startSector As Decimal
		Dim hbfFile As HugeBinaryFile
		Dim tmr As Single
		Dim eTmr As Single
		Dim rawnandTrunkSize As Decimal
		
		On Error GoTo ERR_SUB
		
		tmr = VB.Timer()
		
		'If no drive selected, info the user and skip all.
		If m_oSourceSd Is Nothing Then
			MsgBox(LangLabel("MsgSelectDrive", "Please select Drive"), MsgBoxStyle.OKCancel + MsgBoxStyle.Information, LangLabel("Error", "Error"))
			Exit Sub
		ElseIf SetProperPath = False Then 
			'Prosegue solo se  possibile impostare i percorsi corretti
			'MsgBox LangLabel("ERRPath", "Something went wrong in setting and creting Folders"), vbOKCancel + vbInformation, LangLabel("Error", "Error")
			Exit Sub
		Else
			
			startSector = m_oSourceSd.drvStartSector
			
			
			'------------------------------------------------------------------------------------ boot0.bin
			'Inizializzo i pannelli della status bar con il valore di settori
			lblStatus = SetCounterStatusBar(EMU_BOOT0_LENGHT)
			lblStatusBar(2).Text = " Current: BOOT0 "
			
			tmpFileNo = FreeFile
			FileOpen(tmpFileNo, m_sBoot0Path, OpenMode.Binary, , , 1)
			
			m_oSourceSd.readDataToFileId(startSector, EMU_BOOT0_LENGHT, tmpFileNo)
			
			FileClose(tmpFileNo)
			
			If g_bStopOperations Then Exit Sub
			
			'------------------------------------------------------------------------------------ boot1.bin
			'Inizializzo i pannelli della status bar con il valore di settori
			lblStatusBar(1).Text = "Total Blocks: " & CStr(EMU_BOOT1_LENGHT)
			lblStatusBar(2).Text = " Current: BOOT1 "
			
			tmpFileNo = FreeFile
			FileOpen(tmpFileNo, m_sBoot1Path, OpenMode.Binary, , , 1)
			startSector = startSector + (CDec(EMU_BOOT0_LENGHT) / 10000@)
			
			m_oSourceSd.readDataToFileId(startSector, EMU_BOOT1_LENGHT, tmpFileNo)
			
			FileClose(tmpFileNo)
			
			If g_bStopOperations Then Exit Sub
			
			
			'----------------------------------------------------------------------------------- rawnand.bin
			startSector = startSector + (CDec(EMU_BOOT1_LENGHT) / 10000@)
			
			If m_enDstType = basMain.enEmuType.enAtmFile Then
				rawnandTrunkSize = EMU_AMS_NAND_TRUNK_SIZE
			Else
				rawnandTrunkSize = EMU_SX_NAND_TRUNK_SIZE
			End If
			
			
			On Error GoTo ERR_FILE
			For iTrunkNum = 0 To 6
				
				hbfFile = New HugeBinaryFile
				hbfFile.OpenFile(Replace(m_sRawNandPath, "#", CStr(iTrunkNum)))
				
				'Inizializzo i pannelli della status bar con il valore di settori
				lblStatusBar(1).Text = "Total Blocks: " & VB6.Format(CStr(rawnandTrunkSize), "#,###")
				lblStatusBar(2).Text = " Current Rawnand: 0" & CStr(iTrunkNum) & "/07"
				
				m_oSourceSd.readDataToFileId(startSector, rawnandTrunkSize, -1, hbfFile) 'tmpFileNo
				startSector = startSector + (CDec(rawnandTrunkSize) / 10000@)
				
				hbfFile.Flush()
				hbfFile.CloseFile()
				
				If g_bStopOperations Then Exit Sub
				
				
			Next 
			On Error GoTo 0
			
			If m_enDstType = basMain.enEmuType.enAtmFile Then
				rawnandTrunkSize = EMU_AMS_NAND_LAST_TRUNK_SIZE
			Else
				rawnandTrunkSize = EMU_SX_NAND_LAST_TRUNK_SIZE
			End If
			
			
			'Last trunk
			'Inizializzo i pannelli della status bar con il valore di settori
			lblStatusBar(0).Text = "Total Block: " & CStr(rawnandTrunkSize)
			lblStatusBar(2).Text = " Current Rawnand: 07/07"
			
			hbfFile = New HugeBinaryFile
			hbfFile.OpenFile(Replace(m_sRawNandPath, "#", "7"))
			
			m_oSourceSd.readDataToFileId(startSector, rawnandTrunkSize, -1, hbfFile)
			
			hbfFile.Flush()
			hbfFile.CloseFile()
			
			'----------------------------------------------------------------------------------- rawnand.bin end
			
			
			eTmr = VB.Timer()
			
			If m_enDstType = basMain.enEmuType.enAtmFile Then
				
				MsgBox(LangLabel("NinFoldWarn", "Warning!" & vbCrLf & "Remember to copy " & m_oSourceSd.drvNinFolder & " Folder" & vbCrLf & "From SD Card" & vbCrLf & "To " & m_sOutPath & "emuMMC\HPE0\Nintendo"), MsgBoxStyle.OKOnly, "Copy Folder")
				
			Else
				
				MsgBox(LangLabel("NinFoldWarn", "Warning!" & vbCrLf & "Remember to copy Emutendo Folder from SD Card" & vbCrLf & "To " & m_sOutPath & "Emutendo"), MsgBoxStyle.OKOnly, "Copy Folder") ', vbOKOnly, "Copy Folder"
				
			End If
			
		End If
		
		
EXIT_SUB: 
		
		SetInitialStatusBar()
		MsgBox(LangLabel("EndDump", "Hey, I did it in") & " " & CStr((eTmr - tmr) \ 60) & "min. " & CStr(CShort((eTmr - tmr) - (((eTmr - tmr) \ 60) * 60))) & "sec.", MsgBoxStyle.OKOnly, LangLabel("EndDumpT", "Finish"))
		
		
		Exit Sub
		
ERR_SUB: 
		
		If Err.Number = 13 Then
			MsgBox(LangLabel("BadIni", "emummc.ini file is not properly configured for hidden partition emu"), MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "Error!")
			Resume EXIT_SUB
		Else
			MsgBox(LangLabel("Errore", "Errore") & ": " & Err.Number & " - " & Err.Description)
			Resume EXIT_SUB
		End If
		
		
ERR_FILE: 
		MsgBox(Err.Number & " - " & Err.Description)
		Resume EXIT_SUB
		
		
	End Sub
	
	
	
	'Procedure to byte copy from file to a partition
	Private Sub FileToPartition()
		
		Dim hbfSrc As HugeBinaryFile 'File Sorgente
		Dim startSector As Decimal
		Dim SrcTrunkTotal As Decimal
		Dim idx As Short
		Dim sPoint As String
		Dim SrcTrunkNum As Short
		Dim sBuffer(3) As Byte
		Dim tmr As Single
		Dim eTmr As Single
		Dim sTmp As String
		Dim tmpFileNo As Integer
		Dim bSingleFile As Boolean
		
		On Error GoTo ERR_SUB
		
		tmr = VB.Timer()
		
		'If no drive selected, info the user and skip all.
		If m_oTargetSd Is Nothing Then
			MsgBox(LangLabel("MsgSelectDrive", "Please select Target Drive"), MsgBoxStyle.OKCancel + MsgBoxStyle.Information, LangLabel("Error", "Error"))
			Exit Sub
		ElseIf SetProperPath = False Then 
			'Prosegue solo se  possibile impostare i percorsi corretti
			'MsgBox LangLabel("ERRPath", "Something went wrong in setting and creting Folders"), vbOKCancel + vbInformation, LangLabel("Error", "Error")
			Exit Sub
		Else
			
			startSector = m_oTargetSd.drvStartSector
			
			'''''''''------------------------------------------------------------------------------------ boot0.bin
			'Set Initial file from user choice
			hbfSrc = New HugeBinaryFile
			lblStatus = SetCounterStatusBar(EMU_BOOT0_LENGHT)
			lblStatusBar(2).Text = " Current: BOOT0 "
			
			If hbfSrc.OpenFile(m_sSBoot0Path, True) Then
				SrcTrunkTotal = hbfSrc.FileLen_Renamed
				
				m_oTargetSd.readDataFromFileId(startSector, hbfSrc)
				
				hbfSrc.CloseFile()
				'UPGRADE_NOTE:  possibile che l'oggetto hbfSrc non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
				hbfSrc = Nothing
			Else
				MsgBox("BOOT0 not found!", MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "File not Found")
				SetInitialStatusBar()
				Exit Sub
			End If
			
			'startSector = startSector + (CCur(EMU_BOOT0_LENGHT) / 10000@)
			startSector = startSector + (SrcTrunkTotal / EMU_BLOCK_SIZE) / 10000@
			
			'''''''''------------------------------------------------------------------------------------ boot1.bin
			'Set Initial file from user choice
			hbfSrc = New HugeBinaryFile
			lblStatusBar(1).Text = "Total Blocks: " & VB6.Format(CStr(EMU_BOOT1_LENGHT), "#,###")
			lblStatusBar(2).Text = " Current: BOOT1 "
			
			If hbfSrc.OpenFile(m_sSBoot1Path, True) Then
				SrcTrunkTotal = hbfSrc.FileLen_Renamed
				
				m_oTargetSd.readDataFromFileId(startSector, hbfSrc)
				
				hbfSrc.CloseFile()
				'UPGRADE_NOTE:  possibile che l'oggetto hbfSrc non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
				hbfSrc = Nothing
			Else
				MsgBox("BOOT1 not found!", MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "File not Found")
				SetInitialStatusBar()
				Exit Sub
			End If
			
			'startSector = startSector + (CCur(EMU_BOOT1_LENGHT) / 10000@)
			startSector = startSector + (SrcTrunkTotal / EMU_BLOCK_SIZE) / 10000@
			
			
			
			
			'----------------------------------------------------------------------------------- rawnand.bin
			'Avvio una copia di tutti i byte possibili
			'Sistemo i puntatori
			'se puntatore sorgente  arrivato alla fine allora cambio file sorgente
			'se puntatore destinatario  arrivato allora cambio destinatario
			
			SrcTrunkTotal = 0
			'DstTrunkNum = -1
			
			'Controllo se esiste un file unico di backup hekate
			If m_enSrcType = basMain.enEmuType.enHekBack Then
				On Error GoTo HEKCHECKERR
				tmpFileNo = FreeFile
				bSingleFile = True
				FileOpen(tmpFileNo, Replace(m_sSRawNandPath, "#", ""), OpenMode.Input)
				FileClose(tmpFileNo)
				On Error GoTo ERR_SUB
			End If
			
			'Se  un backup Hekate con singolo file allora prendi solo quello
			If m_enSrcType = basMain.enEmuType.enHekBack And bSingleFile Then
				
				hbfSrc = New HugeBinaryFile
				If hbfSrc.OpenFile(Replace(m_sSRawNandPath, "#", ""), True) Then
					SrcTrunkNum = SrcTrunkNum + 1
					SrcTrunkTotal = hbfSrc.FileLen_Renamed
					
					'Inizializzo i pannelli della status bar con il valore di settori
					lblStatusBar(1).Text = "Total Blocks: " & VB6.Format(CStr(SrcTrunkTotal / EMU_BLOCK_SIZE), "#,###")
					lblStatusBar(2).Text = " Current Rawnand: 0" & CStr(SrcTrunkNum - 1) & "/01"
					
					'Avvio una copia dei byte che devo leggete
					m_oTargetSd.readDataFromFileId(startSector, hbfSrc)
					
					'startSector = startSector + (CCur(EMU_BOOT1_LENGHT) / 10000@)
					startSector = startSector + (SrcTrunkTotal / EMU_BLOCK_SIZE) / 10000@
					hbfSrc.CloseFile()
				End If
				
				'altrimenti prendi i file splittati come al solito.
			Else
				
				If m_enSrcType = basMain.enEmuType.enHekBack Then sPoint = "." Else sPoint = ""
				
				For idx = 0 To 50
					hbfSrc = New HugeBinaryFile
					'If hbfSrc.OpenFile(Replace(m_sSRawNandPath, "#", CStr(SrcTrunkNum)), True) Then
					If hbfSrc.OpenFile(Replace(m_sSRawNandPath, "#", sPoint & VB6.Format(CStr(SrcTrunkNum), "00")), True) Then
						
						SrcTrunkNum = SrcTrunkNum + 1
						SrcTrunkTotal = hbfSrc.FileLen_Renamed
						
						'Inizializzo i pannelli della status bar con il valore di settori
						lblStatusBar(1).Text = "Total Blocks: " & VB6.Format(CStr(SrcTrunkTotal / EMU_BLOCK_SIZE), "#,###")
						lblStatusBar(2).Text = " Current Rawnand: 0" & CStr(SrcTrunkNum - 1) & "/07"
						
						'Avvio una copia dei byte che devo leggete
						m_oTargetSd.readDataFromFileId(startSector, hbfSrc)
						
						'startSector = startSector + (CCur(EMU_BOOT1_LENGHT) / 10000@)
						startSector = startSector + (SrcTrunkTotal / EMU_BLOCK_SIZE) / 10000@
						hbfSrc.CloseFile()
					Else
						If idx > 0 And idx < 8 Then
							MsgBox("Last parsed file is: " & Replace(m_sSRawNandPath, "#", CStr(SrcTrunkNum - 1)))
						ElseIf idx = 0 Then 
							MsgBox("No File found!")
						End If
						Exit For
					End If
					
				Next 
				
			End If
			
			eTmr = VB.Timer()
			
			If m_enDstType = basMain.enEmuType.enAtmHidden Then
				
				On Error Resume Next
				MkDir(m_oTargetSd.drvName & "\emummc")
				
				'Creo il file emummc.ini
				tmpFileNo = FreeFile
				FileOpen(tmpFileNo, m_oTargetSd.drvName & "\emuMMC\emummc.ini", OpenMode.Output)
				PrintLine(tmpFileNo, "[emummc]")
				PrintLine(tmpFileNo, "enabled=1")
				PrintLine(tmpFileNo, "sector=0x" & CStr(Hex(m_oTargetSd.drvStartSector * 10000)))
				PrintLine(tmpFileNo, "path=emuMMC/RAW9")
				PrintLine(tmpFileNo, "id=0x0000")
				PrintLine(tmpFileNo, "nintendo_path=emuMMC/RAW9/Nintendo")
				PrintLine(tmpFileNo, "")
				FileClose(tmpFileNo)
				
				MkDir(m_oTargetSd.drvName & "\emummc\RAW9")
				Kill(m_oTargetSd.drvName & "\emummc\RAW9\*.*")
				
				'm_oTargetSd.drvStartSector = 70467.9936
				
				sTmp = CStr(Hex(m_oTargetSd.drvStartSector * 10000))
				
				sBuffer(3) = Val("&h" & Mid(sTmp, 1, 2))
				sBuffer(2) = Val("&h" & Mid(sTmp, 3, 2))
				sBuffer(1) = Val("&h" & Mid(sTmp, 5, 2))
				sBuffer(0) = Val("&h" & Mid(sTmp, 7, 2))
				
				
				'0x2a009000
				'00 90 00 2A
				
				'                Set hbfSrc = New HugeBinaryFile
				'                hbfSrc.OpenFile m_oTargetSd.drvName & "\emuMMC\RAW9\raw_based", False
				'                hbfSrc.WriteBytes sBuffer
				'                hbfSrc.Flush
				'                hbfSrc.CloseFile
				
				tmpFileNo = FreeFile
				FileOpen(tmpFileNo, m_oTargetSd.drvName & "\emuMMC\RAW9\raw_based", OpenMode.Binary, OpenAccess.Write)
				'UPGRADE_WARNING: Put  stato aggiornato a FilePut e ha un nuovo comportamento. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="9B7D5ADD-D8FE-4819-A36C-6DEDAF088CC7"'
				FilePut(tmpFileNo, sBuffer)
				FileClose(tmpFileNo)
				
				On Error GoTo 0
				
				MsgBox(LangLabel("NinFoldWarn", "Warning!" & vbCrLf & "Remember to copy Nintendo Folder to SD Card" & vbCrLf & "in " & m_oTargetSd.drvName & "\emuMMC\RAW9\Nintendo"), MsgBoxStyle.OKOnly, "Copy Folder")
				
			Else
				
				MsgBox(LangLabel("NinFoldWarn", "Warning!" & vbCrLf & "remember to copy Emutendo Folder To SD Card"), MsgBoxStyle.OKOnly, "Copy Folder")
				
			End If
			
		End If
		
		SetInitialStatusBar()
		
		MsgBox(LangLabel("EndDump", "Hey, I did it in") & " " & CStr((eTmr - tmr) \ 60) & "min. " & CStr(CShort((eTmr - tmr) - (((eTmr - tmr) \ 60) * 60))) & "sec.", MsgBoxStyle.OKOnly, LangLabel("EndDumpT", "Finish"))
		
		
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
HEKCHECKERR: 
		bSingleFile = False
		Resume Next
		
	End Sub
	
	
	'Procedure to "convert" from one type of file to another.
	Private Sub FileToFile()
		
		Dim hbfSrc As HugeBinaryFile 'File Sorgente
		Dim hbfDst As HugeBinaryFile 'File Destinatario
		Dim aBuffer() As Byte 'Buffer di lettura/scrittura
		Dim sSrcPath As String
		Dim SrcTrunkTotal As Decimal
		Dim DstTrunkPointer As Decimal
		Dim DstTrunkTotal As Decimal
		Dim DstTrunkNum As Short
		Dim SrcTrunkPointer As Decimal
		Dim SrcTrunkNum As Short
		
		Dim BytesWritten As Decimal
		Dim BytesToWrite As Decimal
		Dim rawnandTrunkSize As Decimal
		
		Dim tmpFileNo As Short
		Dim tmr As Single
		Dim idx As Short
		Dim sPoint As String
		
		On Error GoTo ERR_SUB
		
		tmr = VB.Timer()
		
		'Prosegue solo se  possibile impostare i percorsi corretti
		If SetProperPath = True Then
			
			'''''''''------------------------------------------------------------------------------------ boot0.bin
			'Set Initial file from user choice
			hbfSrc = New HugeBinaryFile
			lblStatus = SetCounterStatusBar(EMU_BOOT0_LENGHT)
			lblStatusBar(2).Text = " Current: BOOT0 "
			
			
			
			If hbfSrc.OpenFile(m_sSBoot0Path, True) Then
				SrcTrunkTotal = hbfSrc.FileLen_Renamed
				ReDim aBuffer(SrcTrunkTotal - 1)
				hbfSrc.ReadBytes(aBuffer)
				
				hbfDst = New HugeBinaryFile
				hbfDst.OpenFile(m_sBoot0Path, False)
				hbfDst.WriteBytes(aBuffer)
				hbfDst.Flush()
			Else
				MsgBox("BOOT0 not found!", MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "File not Found")
				SetInitialStatusBar()
				Exit Sub
			End If
			
			
			
			'''''''''------------------------------------------------------------------------------------ boot1.bin
			'Inizializzo i pannelli della status bar con il valore di settori
			lblStatusBar(1).Text = "Total Blocks: " & CStr(EMU_BOOT1_LENGHT)
			lblStatusBar(2).Text = " Current: BOOT1 "
			
			'Set Initial file from user choice
			hbfSrc = New HugeBinaryFile
			If hbfSrc.OpenFile(m_sSBoot1Path, True) Then
				SrcTrunkTotal = hbfSrc.FileLen_Renamed
				ReDim aBuffer(SrcTrunkTotal - 1)
				hbfSrc.ReadBytes(aBuffer)
				
				hbfDst = New HugeBinaryFile
				hbfDst.OpenFile(m_sBoot1Path, False)
				hbfDst.WriteBytes(aBuffer)
				hbfDst.Flush()
			Else
				MsgBox("BOOT1 not found!", MsgBoxStyle.Exclamation + MsgBoxStyle.OKOnly, "File not Found")
				SetInitialStatusBar()
				Exit Sub
			End If
			
			
			'----------------------------------------------------------------------------------- rawnand.bin
			
			'Inizializzo i pannelli della status bar con il valore di settori
			lblStatusBar(1).Text = "Total Blocks: 7" ' & CStr(7)
			sSrcPath = m_sSRawNandPath
			SrcTrunkTotal = 0
			
			DstTrunkNum = -1
			
			'Set the correct trunk size based on type of destination
			If m_enDstType = basMain.enEmuType.enAtmFile Then
				DstTrunkTotal = EMU_AMS_NAND_TRUNK_SIZE * EMU_BLOCK_SIZE
			Else
				DstTrunkTotal = EMU_SX_NAND_TRUNK_SIZE * EMU_BLOCK_SIZE
			End If
			
			
			If m_enSrcType = basMain.enEmuType.enHekBack Then sPoint = "." Else sPoint = ""
			
			
			DstTrunkPointer = DstTrunkTotal 'To start the initialization of the first file in the second if
			
			
			'Determino il segmento minore
			'Avvio una copia di tutti i byte possibili
			'Sistemo i puntatori
			'se puntatore sorgente  arrivato alla fine allora cambio file sorgente
			'se puntatore destinatario  arrivato allora cambio destinatario
			
			
			'If hbfSrc.OpenFile(Replace(m_sSRawNandPath, "#", sPoint & Format(CStr(SrcTrunkNum), "00")), True) Then
			
			
			Do 
				If SrcTrunkPointer >= SrcTrunkTotal Then
					'Carico il file sorgente
					hbfSrc = New HugeBinaryFile
					On Error Resume Next
					If Not hbfSrc.OpenFile(Replace(sSrcPath, "#", sPoint & VB6.Format(CStr(SrcTrunkNum), "00")), True) Then
						MsgBox("No more source file availlable" & vbCrLf & "Last parsed file is: " & Replace(sSrcPath, "#", sPoint & VB6.Format(CStr(SrcTrunkNum - 1), "00")))
						Exit Do
					End If
					SrcTrunkNum = SrcTrunkNum + 1
					SrcTrunkTotal = hbfSrc.FileLen_Renamed
					SrcTrunkPointer = 0
				End If
				
				If DstTrunkPointer >= DstTrunkTotal Then
					'Creo il riferimento al file destinatario
					DstTrunkNum = DstTrunkNum + 1
					If DstTrunkNum > 7 Then Exit Do
					
					If Not hbfDst Is Nothing Then hbfDst.CloseFile()
					hbfDst = New HugeBinaryFile
					hbfDst.OpenFile(Replace(m_sRawNandPath, "#", CStr(DstTrunkNum)), False)
					DstTrunkPointer = 0
				End If
				
				
				' Determina il minore tra cosa resta da leggere e da scrivere
				If (DstTrunkTotal - DstTrunkPointer) < (SrcTrunkTotal - SrcTrunkPointer) Then
					'meno da scrivere che da leggere
					BytesToWrite = (DstTrunkTotal - DstTrunkPointer)
				Else
					'meno da leggere che da scrivere
					BytesToWrite = (SrcTrunkTotal - SrcTrunkPointer)
				End If
				
				'Inizializzo i pannelli della status bar con il valore di settori
				lblStatusBar(1).Text = "Total Blocks: " & VB6.Format(CStr(DstTrunkTotal / EMU_BLOCK_SIZE), "#,###")
				lblStatusBar(2).Text = " Current Rawnand: 0" & CStr(DstTrunkNum) & "/07"
				
				
				'Avvio una copia dei byte che devo leggete
				BytesWritten = hbfSrc.readDataToFileId(SrcTrunkPointer, BytesToWrite, DstTrunkPointer, hbfDst)
				hbfDst.Flush()
				
				SrcTrunkPointer = SrcTrunkPointer + BytesWritten
				DstTrunkPointer = DstTrunkPointer + BytesWritten
				
			Loop While DstTrunkNum < 8 'Next
			
			If Not hbfSrc Is Nothing Then hbfSrc.CloseFile()
			If Not hbfDst Is Nothing Then
				hbfDst.Flush()
				hbfDst.CloseFile()
			End If
			
			
			
			''''''''
			''''''''        'Last trunk
			''''''''        'Inizializzo i pannelli della status bar con il valore di settori
			''''''''        lblStatusBar(0).Caption = "Total Block: " & CStr(EMU_SX_NAND_LAST_TRUNK_SIZE)
			''''''''        lblStatusBar(2).Caption = " Current: Rawnand07"
			''''''''
			''''''''        Set hbfFile = New HugeBinaryFile
			''''''''        hbfFile.OpenFile Replace(m_sRawNandPath, "#", "7")
			''''''''
			''''''''        m_oDrive.readDataToFileId startSector, EMU_SX_NAND_LAST_TRUNK_SIZE, -1, hbfFile
			''''''''
			''''''''        hbfFile.Flush
			''''''''        hbfFile.CloseFile
			''''''''
			'----------------------------------------------------------------------------------- rawnand.bin end
			
			
			
			
			''''        If m_enDstType = enAtmFile Then
			''''
			''''            'Creo il file emummc.ini
			''''            tmpFileNo = FreeFile
			''''            Open m_sOutPath & "\emuMMC\emummc.ini" For Output As tmpFileNo
			''''            Print #tmpFileNo, "[emummc]"
			''''            Print #tmpFileNo, "enabled=1"
			''''            Print #tmpFileNo, "sector=0x0"
			''''            Print #tmpFileNo, "path=emuMMC/HPE0"
			''''            Print #tmpFileNo, "id=0x0000"
			''''            Print #tmpFileNo, "nintendo_path=emuMMC/HPE0/Nintendo"
			''''            Print #tmpFileNo, ""
			''''            Close tmpFileNo
			''''
			''''
			''''            tmpFileNo = FreeFile
			''''            Open App.Path & "\emuMMC\HPE0\file_based" For Output As tmpFileNo
			''''            Close tmpFileNo
			''''
			''''        End If
			
			
		End If
		
		
EXIT_SUB: 
		
		SetInitialStatusBar()
		MsgBox(LangLabel("EndDump", "Hey, I did it in") & " " & CStr(VB.Timer() - tmr) & "sec.", MsgBoxStyle.OKOnly, LangLabel("EndDumpT", "Finish"))
		Exit Sub
		
ERR_SUB: 
		
		If Err.Number = 13 Then
			MsgBox(LangLabel("BadIni", "emummc.ini file is not properly configured for hidden partition emu"), MsgBoxStyle.OKOnly + MsgBoxStyle.Exclamation, "Error!")
			Resume EXIT_SUB
		Else
			MsgBox(LangLabel("Errore", "Errore") & ": " & Err.Number & " - " & Err.Description)
			Resume Next ' EXIT_SUB
		End If
		
		
ERR_FILE: 
		MsgBox(Err.Number & " - " & Err.Description)
		Resume EXIT_SUB
		
		
	End Sub
	
	
	Private Sub txtSrcSd_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles txtSrcSd.Click
		Dim Index As Short = txtSrcSd.GetIndex(eventSender)
		
		On Error GoTo ERR_SUB
		
		'Cliccato su sorgente
		If Index = 0 Then
			Select Case m_enSrcType
				Case basMain.enEmuType.enAtmFile, basMain.enEmuType.enSxFile, basMain.enEmuType.enHekBack
					frmFolder.sEmuFolder = m_sSourcePath
					frmFolder.isTarget = False
					frmFolder.ShowDialog()
					If Trim(frmFolder.sEmuFolder) = "" Then Exit Sub
					
					m_sSourcePath = frmFolder.sEmuFolder
					frmFolder.sEmuFolder = ""
					
					'UPGRADE_NOTE:  possibile che l'oggetto m_oSourceSd non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					m_oSourceSd = Nothing
					txtSrcSd(Index).Text = "Path: " & vbCrLf & m_sSourcePath
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					fraSxEmu.Visible = False
					
				Case basMain.enEmuType.enAtmHidden
					frmSD.isTarget = False
					frmSD.enTipo = basMain.enEmuType.enAtmHidden
					frmSD.ShowDialog()
					If frmSD.oDrive Is Nothing Then Exit Sub
					m_oSourceSd = frmSD.oDrive
					'UPGRADE_NOTE:  possibile che l'oggetto frmSD.oDrive non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					frmSD.oDrive = Nothing
					
					txtSrcSd(Index).Text = "Drive: " & m_oSourceSd.drvName & " (" & m_oSourceSd.drvModel & ")"
                    txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Partition Sector: 0x" & CStr(Hex(m_oSourceSd.drvStartSector)) ' * 10000@))
					txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Nintendo Path: " & CStr(m_oSourceSd.drvNinFolder)
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					
					fraSxEmu.Visible = False
					m_sSourcePath = ""
					
				Case basMain.enEmuType.enSxHidden
					frmSD.isTarget = False
					frmSD.enTipo = basMain.enEmuType.enSxHidden
					frmSD.ShowDialog()
					If frmSD.oDrive Is Nothing Then Exit Sub
					m_oSourceSd = frmSD.oDrive
					'UPGRADE_NOTE:  possibile che l'oggetto frmSD.oDrive non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					frmSD.oDrive = Nothing
					
					'Imposta il settore di default
					m_oSourceSd.drvStartSector = 0.0002
					m_oSourceSd.drvEmuFolder = "sxos\Emunand"
					m_oSourceSd.drvNinFolder = "Emutendo"
					txtSrcSd(Index).Text = "Drive: " & m_oSourceSd.drvName & " (" & m_oSourceSd.drvModel & ")"
                    txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Partition Sector: 0x" & CStr(Hex(m_oSourceSd.drvStartSector))   ' * 10000))
					txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Nintendo Path: " & CStr(m_oSourceSd.drvNinFolder)
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					
					fraSxEmu.Visible = True
					m_sSourcePath = ""
					
					If Not m_oSourceSd Is Nothing Then
						m_bLoadingForm = True
						If m_oSourceSd.sxPartitionEnabled Then
							optSetSx(0).Checked = True
						Else
							optSetSx(1).Checked = True
						End If
						m_bLoadingForm = False
					End If
					
				Case Else
					
			End Select
			
			'Cliccato su destinatario
		Else
			
			Select Case m_enDstType
				Case basMain.enEmuType.enAtmFile, basMain.enEmuType.enSxFile
					frmFolder.sEmuFolder = m_sOutPath
					frmFolder.isTarget = True
					frmFolder.ShowDialog()
					If Trim(frmFolder.sEmuFolder) = "" Then Exit Sub
					m_sOutPath = frmFolder.sEmuFolder
					frmFolder.sEmuFolder = ""
					
					'UPGRADE_NOTE:  possibile che l'oggetto m_oTargetSd non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					m_oTargetSd = Nothing
					
					txtSrcSd(Index).Text = "Path: " & vbCrLf & m_sOutPath
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					
				Case basMain.enEmuType.enAtmHidden
					frmSD.isTarget = True
					frmSD.enTipo = basMain.enEmuType.enAtmHidden
					frmSD.ShowDialog()
					If frmSD.oDrive Is Nothing Then Exit Sub
					m_oTargetSd = frmSD.oDrive
					
					'm_oTargetSd.drvStartSector = m_oTargetSd.drvStartSector + (32768 / 10000@)
					
					'UPGRADE_NOTE:  possibile che l'oggetto frmSD.oDrive non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					frmSD.oDrive = Nothing
					m_sOutPath = ""
					
					txtSrcSd(Index).Text = "Drive: " & m_oTargetSd.drvName & " (" & m_oTargetSd.drvModel & ")"
                    txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Partition Sector: 0x" & CStr(Hex(m_oTargetSd.drvStartSector))  '* 10000@))
					txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Nintendo Path: " & CStr(m_oTargetSd.drvNinFolder)
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					
					m_sOutPath = ""
					
				Case basMain.enEmuType.enSxHidden
					frmSD.isTarget = True
					frmSD.enTipo = basMain.enEmuType.enSxHidden
					frmSD.ShowDialog()
					If frmSD.oDrive Is Nothing Then Exit Sub
					m_oTargetSd = frmSD.oDrive
					'UPGRADE_NOTE:  possibile che l'oggetto frmSD.oDrive non venga eliminato in modo permanente finch non venga raccolto nel Garbage Collector. Fare clic per ulteriori informazioni: 'ms-help://MS.VSCC.v90/dv_commoner/local/redirect.htm?keyword="6E35BFF6-CD74-4B09-9689-3E1A43DF8969"'
					frmSD.oDrive = Nothing
					m_sOutPath = ""
					
					'Imposta il settore di default
					m_oTargetSd.drvStartSector = 0.0002
					m_oTargetSd.drvEmuFolder = "sxos\Emunand"
					m_oTargetSd.drvNinFolder = "Emutendo"
					txtSrcSd(Index).Text = "Drive: " & m_oTargetSd.drvName & " (" & m_oTargetSd.drvModel & ")"
                    txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Partition Sector: 0x" & CStr(Hex(m_oTargetSd.drvStartSector))  '* 10000@))
					txtSrcSd(Index).Text = txtSrcSd(Index).Text & vbCrLf & "Nintendo Path: " & CStr(m_oTargetSd.drvNinFolder)
					'txtSrcSd(Index).FontBold = False
					txtSrcSd(Index).TextAlign = System.Windows.Forms.HorizontalAlignment.Left
					m_sOutPath = ""
					
				Case Else
					
			End Select
			
		End If
		
		'm_oSelectedSd
EXIT_SUB: 
		Exit Sub
		
ERR_SUB: 
		MsgBox("txtSrcSD Unexpected Error n." & Err.Number & vbCrLf & Err.Description)
		Resume EXIT_SUB
		
		
	End Sub

    Protected Overrides Sub Finalize()
        MyBase.Finalize()
    End Sub
End Class